function [ G2Basis filterHalfSize ] = init3DG2(input, sigma)
%INIT... Compute convolutions of input with basis functions for steerable filters.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

% Define basis functions
if nargin < 2, sigma = 1.0; end % Missing argument: set default value
filterHalfSize = 4 * sigma;
t = [-filterHalfSize : filterHalfSize] ./ (sqrt(2) * sigma);
%C = (2/sqrt(3)) * (2/pi)^(3/4);
C = 0.41146;
basis(1, :) = C * (2 * t.^2 - 1) .* exp(-t.^2);
basis(2, :) = exp(-t.^2);
basis(3, :) = 2 * C * t .* exp(-t.^2); 
basis(4, :) = t .* exp(-t.^2);

% Convolve the input with the basis
G2Basis{1}  = convolveBasis3D(input, basis, [1 2 2]);
G2Basis{2}  = convolveBasis3D(input, basis, [3 4 2]);
G2Basis{3}  = convolveBasis3D(input, basis, [2 1 2]);
G2Basis{4}  = convolveBasis3D(input, basis, [3 2 4]);
G2Basis{5}  = convolveBasis3D(input, basis, [2 3 4]);
G2Basis{6}  = convolveBasis3D(input, basis, [2 2 1]);
