function result = steer3DG2(direction, G2Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(numel(direction) == 3);
assert(abs(norm(direction) - 1) <= 2*eps); % Direction must be a unit vector (or close to)
a = direction(1);
b = direction(2);
c = direction(3);

result = (a^2) * G2Basis{1} ... 
       + 2*a*b * G2Basis{2} ...
       + (b^2) * G2Basis{3} ...
       + 2*a*c * G2Basis{4} ...
       + 2*b*c * G2Basis{5} ...
       + (c^2) * G2Basis{6};
