function result = steer3DG3(direction, G3Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(numel(direction) == 3);
assert(abs(norm(direction) - 1) <= 2*eps); % Direction must be a unit vector (or close to)
a = direction(1);
b = direction(2);
c = direction(3);

result = G3Basis{1} * a^3 ...
       + G3Basis{2} * 3*a^2*b ...
       + G3Basis{3} * 3*a*b^2 ...
       + G3Basis{4} * b^3 ...
       + G3Basis{5} * 3*a^2*c ...
       + G3Basis{6} * 6*a*b*c ...
       + G3Basis{7} * 3*b^2*c ...
       + G3Basis{8} * 3*a*c^2 ...
       + G3Basis{9} * 3*b*c^2 ...
       + G3Basis{10} * c^3;
