function result = steer3DG4(direction, G4Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(numel(direction) == 3);
assert(abs(norm(direction) - 1) <= 2*eps); % Direction must be a unit vector (or close to)
a = direction(1);
b = direction(2);
c = direction(3);

result = G4Basis{1} * a^4 ...
       + G4Basis{2} * 4*a^3*b ...
       + G4Basis{3} * 6*a^2*b^2 ...
       + G4Basis{4} * 4*a*b^3 ...
       + G4Basis{5} * b^4 ...
       + G4Basis{6} * 4*a^3*c ...
       + G4Basis{7} * 12*a^2*b*c ...
       + G4Basis{8} * 12*a*b^2*c ...
       + G4Basis{9} * 4*b^3*c ...
       + G4Basis{10} * 6*a^2*c^2 ...
       + G4Basis{11} * 12*a*b*c^2 ...
       + G4Basis{12} * 6*b^2*c^2 ...
       + G4Basis{13} * 4*a*c^3 ...
       + G4Basis{14} * 4*b*c^3 ...
       + G4Basis{15} * c^4;
