function result = steer3DH2(direction, H2Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(numel(direction) == 3);
assert(abs(norm(direction) - 1) <= 2*eps); % Direction must be a unit vector (or close to)
a = direction(1);
b = direction(2);
c = direction(3);

result = (a^3)     * H2Basis{1}...
       + 3*(a^2)*b * H2Basis{2} ... 
       + 3*a*(b^2) * H2Basis{3} ...
       + (b^3)     * H2Basis{4} ...
       + 3*(a^2)*c * H2Basis{5} ...
       + 6*a*b*c   * H2Basis{6} ...
       + 3*(b^2)*c * H2Basis{7} ...
       + 3*a*(c^2) * H2Basis{8} ...
       + 3*b*(c^2) * H2Basis{9} ...
       + (c^3)     * H2Basis{10};
