function result = steer3DH3(direction, H3Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(numel(direction) == 3);
assert(abs(norm(direction) - 1) <= 2*eps); % Direction must be a unit vector (or close to)
a = direction(1);
b = direction(2);
c = direction(3);

result = H3Basis{1} * a^4 ...
       + H3Basis{2} * 4*a^3*b ...
       + H3Basis{3} * 6*a^2*b^2 ...
       + H3Basis{4} * 4*a*b^3 ...
       + H3Basis{5} * b^4 ...
       + H3Basis{6} * 4*a^3*c ...
       + H3Basis{7} * 12*a^2*b*c ...
       + H3Basis{8} * 12*a*b^2*c ...
       + H3Basis{9} * 4*b^3*c ...
       + H3Basis{10} * 6*a^2*c^2 ...
       + H3Basis{11} * 12*a*b*c^2 ...
       + H3Basis{12} * 6*b^2*c^2 ...
       + H3Basis{13} * 4*a*c^3 ...
       + H3Basis{14} * 4*b*c^3 ...
       + H3Basis{15} * c^4;
