function result = steerG2(theta, G2Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(length(G2Basis) == 3);

result = G2Basis{1} * cos(theta)^2 ...
       + G2Basis{2} * -2*cos(theta)*sin(theta) ...
       + G2Basis{3} * sin(theta)^2;
