function result = steerH2(theta, H2Basis)
%STEER... Steer filter to given direction using the given basis images.

% Author: Damien Teney, inspired by code from Konstatinos G. Derpanis

assert(length(H2Basis) == 4);

result = H2Basis{1} * cos(theta)^3 ...
       + H2Basis{2} * -3*(cos(theta)^2)*sin(theta) ...
       + H2Basis{3} * 3*cos(theta)*(sin(theta)^2) ...
       + H2Basis{4} *-sin(theta)^3;
