function video = convertVideoToGrayscale(video)
%CONVERTVIDEOTOGRAYSCALE Convert a RGB video to grayscale (dimensions: height x width x nFrames).

%   Author: Damien Teney

assert(size(video, 4) == 3); % Check that the input video has 3 channels

for frameId = 1:size(video, 3) % For each frame
  video(:, :, frameId, 1) = rgb2gray(squeeze(video(:, :, frameId, :)));
end

% Remove the two unused channels
video = squeeze(video(:, :, :, 1));
