function flowUV = flowPolarToUv(flowPolar)
%FLOWPOLARTOUV Convert a matrix of optical flow of a video from polar (angle/magnitude) to UV representation.

%   Author: Damien Teney

% Check input dimensions
assert(ndims(flowPolar) == 4);
assert(size(flowPolar, 4) == 2);

flowU = flowPolar(:, :, :, 2) .* cos(flowPolar(:, :, :, 1));
flowV = flowPolar(:, :, :, 2) .* sin(flowPolar(:, :, :, 1));

flowUV = cat(4, flowU, flowV);
