function generateOutputVideos(pixelAssignment, nodes, resultPath, level)
%GENERATEOUTPUTVIDEOS

%   Author: Damien Teney

% Declare constants
% Column indices in 'nodes'
MST_WEIGHT = 1; SIZE = 2; RANK = 3; VARIANCE = 4; COLOR = 5; MIN_FRAME = 8; MAX_FRAME = 9; MIN_X = 10; MAX_X = 11; MIN_Y = 12; MAX_Y = 13; HISTOGRAMS = 14;

% Get RGB colors of all segments
nodesColors = nodes(:, COLOR : (COLOR + 2));

if ~exist(resultPath, 'dir'), mkdir(resultPath); end % Create the output directory

% Initialize the video writer
outputFileName =  sprintf('%s%sSegmentation_%02u.avi', resultPath, filesep, level);
videoFileObject = VideoWriter(outputFileName);
%videoFileObject = VideoWriter(outputFileName, 'Uncompressed AVI');
%videoFileObject.FrameRate = 4;
open(videoFileObject);

nFrames = size(pixelAssignment, 3);
for frameId = 1:nFrames
  outputFrame = ind2rgb(pixelAssignment(:, :, frameId), nodesColors); % Turn the "indexed image" (pixelAssignment) into an RGB image
  writeVideo(videoFileObject, outputFrame);
end

close(videoFileObject);
